diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mesh/test/dot11s/hwmp-proactive-regression.cc ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.cc
--- ns-3.45/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mesh/test/dot11s/hwmp-proactive-regression.cc	2025-10-01 18:46:32.000000000 -0700
@@ -13,6 +13,7 @@
 #include "ns3/internet-stack-helper.h"
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/ipv4-interface-container.h"
+#include "ns3/log.h"
 #include "ns3/mesh-helper.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/mobility-model.h"
@@ -28,6 +29,8 @@
 
 using namespace ns3;
 
+NS_LOG_COMPONENT_DEFINE("HwmpProactiveRegression");
+
 /// Unique PCAP file name prefix
 const char* const PREFIX = "hwmp-proactive-regression-test";
 
@@ -167,6 +170,7 @@
     {
         socket->Send(Create<Packet>(100));
         m_sentPktsCounter++;
+        NS_LOG_INFO("Send packet; total sent = " << m_sentPktsCounter);
         Simulator::ScheduleWithContext(socket->GetNode()->GetId(),
                                        Seconds(0.5),
                                        &HwmpProactiveRegressionTest::SendData,
@@ -182,6 +186,8 @@
     Address from;
     while ((packet = socket->RecvFrom(from)))
     {
+        NS_LOG_INFO("Receive packet from " << InetSocketAddress::ConvertFrom(from).GetIpv4()
+                                           << "; return to sender");
         packet->RemoveAllPacketTags();
         packet->RemoveAllByteTags();
 
@@ -196,5 +202,6 @@
     Address from;
     while ((packet = socket->RecvFrom(from)))
     {
+        NS_LOG_INFO("Receive packet from " << InetSocketAddress::ConvertFrom(from).GetIpv4());
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/CMakeLists.txt ns-3.46/src/mobility/CMakeLists.txt
--- ns-3.45/src/mobility/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -57,4 +57,5 @@
     test/rectangle-closest-border-test.cc
     test/steady-state-random-waypoint-mobility-model-test.cc
     test/waypoint-mobility-model-test.cc
+  GENERATE_EXPORT_HEADER
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/constant-acceleration-mobility-model.h ns-3.46/src/mobility/model/constant-acceleration-mobility-model.h
--- ns-3.45/src/mobility/model/constant-acceleration-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/constant-acceleration-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -33,6 +33,13 @@
      */
     ConstantAccelerationMobilityModel();
     ~ConstantAccelerationMobilityModel() override;
+
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<ConstantAccelerationMobilityModel>(*this);
+    }
+
     /**
      * Set the model's velocity and acceleration
      * @param velocity the velocity (m/s)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/constant-position-mobility-model.h ns-3.46/src/mobility/model/constant-position-mobility-model.h
--- ns-3.45/src/mobility/model/constant-position-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/constant-position-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -33,6 +33,12 @@
     ConstantPositionMobilityModel();
     ~ConstantPositionMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<ConstantPositionMobilityModel>(*this);
+    }
+
   private:
     Vector DoGetPosition() const override;
     void DoSetPosition(const Vector& position) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/constant-velocity-mobility-model.h ns-3.46/src/mobility/model/constant-velocity-mobility-model.h
--- ns-3.45/src/mobility/model/constant-velocity-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/constant-velocity-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -39,6 +39,12 @@
     ConstantVelocityMobilityModel();
     ~ConstantVelocityMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<ConstantVelocityMobilityModel>(*this);
+    }
+
     /**
      * @param speed the new speed to set.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/gauss-markov-mobility-model.h ns-3.46/src/mobility/model/gauss-markov-mobility-model.h
--- ns-3.45/src/mobility/model/gauss-markov-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/gauss-markov-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -78,6 +78,12 @@
     GaussMarkovMobilityModel();
     ~GaussMarkovMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<GaussMarkovMobilityModel>(*this);
+    }
+
   private:
     /**
      * Initialize the model and calculate new velocity, direction, and pitch
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/geocentric-constant-position-mobility-model.cc ns-3.46/src/mobility/model/geocentric-constant-position-mobility-model.cc
--- ns-3.45/src/mobility/model/geocentric-constant-position-mobility-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/geocentric-constant-position-mobility-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,7 +9,7 @@
 
 #include "ns3/angles.h"
 
-#include <math.h>
+#include <cmath>
 
 /**
  *  @file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/geocentric-constant-position-mobility-model.h ns-3.46/src/mobility/model/geocentric-constant-position-mobility-model.h
--- ns-3.45/src/mobility/model/geocentric-constant-position-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/geocentric-constant-position-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -37,6 +37,12 @@
     GeocentricConstantPositionMobilityModel() = default;
     ~GeocentricConstantPositionMobilityModel() override = default;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<GeocentricConstantPositionMobilityModel>(*this);
+    }
+
     /**
      * @brief Computes elevation angle between a ground terminal and a HAPS/Satellite.
      * After calculating the plane perpendicular to a cartesian position vector,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/hierarchical-mobility-model.h ns-3.46/src/mobility/model/hierarchical-mobility-model.h
--- ns-3.45/src/mobility/model/hierarchical-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/hierarchical-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -54,6 +54,12 @@
 
     HierarchicalMobilityModel();
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<HierarchicalMobilityModel>(*this);
+    }
+
     /**
      * @return the child mobility model.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/mobility-model.h ns-3.46/src/mobility/model/mobility-model.h
--- ns-3.45/src/mobility/model/mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -8,6 +8,7 @@
 #ifndef MOBILITY_MODEL_H
 #define MOBILITY_MODEL_H
 
+#include "ns3/mobility-export.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 #include "ns3/vector.h"
@@ -25,7 +26,7 @@
  *
  * This is a base class for all specific mobility models.
  */
-class MobilityModel : public Object
+class MOBILITY_EXPORT MobilityModel : public Object
 {
   public:
     /**
@@ -37,6 +38,15 @@
     ~MobilityModel() override = 0;
 
     /**
+     * Copy function allows one to copy the underlying MobilityModel
+     * from a MobilityModel pointer, by calling each children Copy implementation.
+     * This is primarily used by wraparound models for the spectrum channel.
+     *
+     * @return a copy of the current mobility model
+     */
+    virtual Ptr<MobilityModel> Copy() const = 0;
+
+    /**
      * @return the current position
      */
     Vector GetPosition() const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/random-direction-2d-mobility-model.h ns-3.46/src/mobility/model/random-direction-2d-mobility-model.h
--- ns-3.45/src/mobility/model/random-direction-2d-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/random-direction-2d-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -42,6 +42,12 @@
     RandomDirection2dMobilityModel();
     ~RandomDirection2dMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<RandomDirection2dMobilityModel>(*this);
+    }
+
   private:
     /**
      * Set a new direction and speed
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/random-walk-2d-mobility-model.h ns-3.46/src/mobility/model/random-walk-2d-mobility-model.h
--- ns-3.45/src/mobility/model/random-walk-2d-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/random-walk-2d-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -48,6 +48,12 @@
 
     ~RandomWalk2dMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<RandomWalk2dMobilityModel>(*this);
+    }
+
     /** An enum representing the different working modes of this module. */
     enum Mode
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/random-waypoint-mobility-model.h ns-3.46/src/mobility/model/random-waypoint-mobility-model.h
--- ns-3.45/src/mobility/model/random-waypoint-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/random-waypoint-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -50,6 +50,12 @@
 
     ~RandomWaypointMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<RandomWaypointMobilityModel>(*this);
+    }
+
   protected:
     void DoInitialize() override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/steady-state-random-waypoint-mobility-model.h ns-3.46/src/mobility/model/steady-state-random-waypoint-mobility-model.h
--- ns-3.45/src/mobility/model/steady-state-random-waypoint-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/steady-state-random-waypoint-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -53,6 +53,12 @@
     SteadyStateRandomWaypointMobilityModel();
     ~SteadyStateRandomWaypointMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<SteadyStateRandomWaypointMobilityModel>(*this);
+    }
+
   protected:
     void DoInitialize() override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mobility/model/waypoint-mobility-model.h ns-3.46/src/mobility/model/waypoint-mobility-model.h
--- ns-3.45/src/mobility/model/waypoint-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mobility/model/waypoint-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -89,6 +89,12 @@
     WaypointMobilityModel();
     ~WaypointMobilityModel() override;
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<WaypointMobilityModel>(*this);
+    }
+
     /**
      * @param waypoint waypoint to append to the object path.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/mpi/model/remote-channel-bundle-manager.cc ns-3.46/src/mpi/model/remote-channel-bundle-manager.cc
--- ns-3.45/src/mpi/model/remote-channel-bundle-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/mpi/model/remote-channel-bundle-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -48,7 +48,7 @@
     NS_ASSERT(!g_initialized);
     NS_ASSERT(g_remoteChannelBundles.find(systemId) == g_remoteChannelBundles.end());
 
-    Ptr<RemoteChannelBundle> remoteChannelBundle = Create<RemoteChannelBundle>(systemId);
+    auto remoteChannelBundle = CreateObject<RemoteChannelBundle>(systemId);
 
     g_remoteChannelBundles[systemId] = remoteChannelBundle;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/netanim/CMakeLists.txt ns-3.46/src/netanim/CMakeLists.txt
--- ns-3.45/src/netanim/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/netanim/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -3,7 +3,6 @@
   SOURCE_FILES model/animation-interface.cc
   HEADER_FILES model/animation-interface.h
   LIBRARIES_TO_LINK
-    ${libwimax}
     ${libwifi}
     ${liblte}
     ${libuan}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/netanim/model/animation-interface.cc ns-3.46/src/netanim/model/animation-interface.cc
--- ns-3.45/src/netanim/model/animation-interface.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/netanim/model/animation-interface.cc	2025-10-01 18:46:32.000000000 -0700
@@ -22,7 +22,6 @@
 
 // ns3 includes
 #ifdef __WIN32__
-#include "ns3/bs-net-device.h"
 #include "ns3/csma-net-device.h"
 #endif
 #include "animation-interface.h"
@@ -49,7 +48,6 @@
 #include "ns3/wifi-mac.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-psdu.h"
-#include "ns3/wimax-mac-header.h"
 
 namespace ns3
 {
@@ -95,11 +93,10 @@
      * The .dll.a/.lib however, only gets linked if we instantiate at
      * least one symbol exported by the .dll.
      *
-     * To ensure TypeIds from the Csma, Uan, Wifi and Wimax
+     * To ensure TypeIds from the Csma, Uan, and Wifi
      * modules are registered during runtime, we need to instantiate
      * at least one symbol exported by each of these module libraries.
      */
-    static BaseStationNetDevice b;
     static CsmaNetDevice c;
     static WifiNetDevice w;
     static UanNetDevice u;
@@ -477,7 +474,6 @@
     if (!Simulator::IsFinished())
     {
         PurgePendingPackets(AnimationInterface::WIFI);
-        PurgePendingPackets(AnimationInterface::WIMAX);
         PurgePendingPackets(AnimationInterface::LTE);
         PurgePendingPackets(AnimationInterface::CSMA);
         PurgePendingPackets(AnimationInterface::LRWPAN);
@@ -1069,20 +1065,6 @@
 }
 
 void
-AnimationInterface::WimaxTxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m)
-{
-    NS_LOG_FUNCTION(this);
-    return GenericWirelessTxTrace(context, p, AnimationInterface::WIMAX);
-}
-
-void
-AnimationInterface::WimaxRxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m)
-{
-    NS_LOG_FUNCTION(this);
-    return GenericWirelessRxTrace(context, p, AnimationInterface::WIMAX);
-}
-
-void
 AnimationInterface::LteTxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m)
 {
     NS_LOG_FUNCTION(this);
@@ -1346,10 +1328,6 @@
         pendingPackets = &m_pendingCsmaPackets;
         break;
     }
-    case AnimationInterface::WIMAX: {
-        pendingPackets = &m_pendingWimaxPackets;
-        break;
-    }
     case AnimationInterface::LTE: {
         pendingPackets = &m_pendingLtePackets;
         break;
@@ -1380,10 +1358,6 @@
         result = "CSMA";
         break;
     }
-    case AnimationInterface::WIMAX: {
-        result = "WIMAX";
-        break;
-    }
     case AnimationInterface::LTE: {
         result = "LTE";
         break;
@@ -1614,10 +1588,6 @@
     Config::ConnectWithoutContextFailSafe(
         "/NodeList/*/$ns3::MobilityModel/CourseChange",
         MakeCallback(&AnimationInterface::MobilityCourseChangeTrace, this));
-    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Tx",
-                            MakeCallback(&AnimationInterface::WimaxTxTrace, this));
-    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::WimaxNetDevice/Rx",
-                            MakeCallback(&AnimationInterface::WimaxRxTrace, this));
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Tx",
                             MakeCallback(&AnimationInterface::LteTxTrace, this));
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::LteNetDevice/Rx",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/netanim/model/animation-interface.h ns-3.46/src/netanim/model/animation-interface.h
--- ns-3.45/src/netanim/model/animation-interface.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/netanim/model/animation-interface.h	2025-10-01 18:46:32.000000000 -0700
@@ -531,7 +531,6 @@
         UAN,
         LTE,
         WIFI,
-        WIMAX,
         CSMA,
         LRWPAN
     };
@@ -652,7 +651,6 @@
     uint32_t m_wifiPhyRxDropCounterId; ///< wifi Phy receive drop counter ID
 
     AnimUidPacketInfoMap m_pendingWifiPackets;   ///< pending wifi packets
-    AnimUidPacketInfoMap m_pendingWimaxPackets;  ///< pending wimax packets
     AnimUidPacketInfoMap m_pendingLrWpanPackets; ///< pending LR-WPAN packets
     AnimUidPacketInfoMap m_pendingLtePackets;    ///< pending LTE packets
     AnimUidPacketInfoMap m_pendingCsmaPackets;   ///< pending CSMA packets
@@ -1079,20 +1077,6 @@
      */
     void LrWpanPhyRxBeginTrace(std::string context, Ptr<const Packet> p);
     /**
-     * WIMax transmit trace function
-     * @param context the context
-     * @param p the packet
-     * @param m the MAC address
-     */
-    void WimaxTxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m);
-    /**
-     * WIMax receive trace function
-     * @param context the context
-     * @param p the packet
-     * @param m the MAC address
-     */
-    void WimaxRxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m);
-    /**
      * CSMA Phy transmit begin trace function
      * @param context the context
      * @param p the packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/CMakeLists.txt ns-3.46/src/network/CMakeLists.txt
--- ns-3.45/src/network/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -101,7 +101,6 @@
     model/tag-buffer.h
     model/tag.h
     model/trailer.h
-    test/header-serialization-test.h
     utils/address-utils.h
     utils/bit-deserializer.h
     utils/bit-serializer.h
@@ -115,6 +114,7 @@
     utils/ethernet-trailer.h
     utils/flow-id-tag.h
     utils/generic-phy.h
+    utils/header-serialization-test.h
     utils/inet-socket-address.h
     utils/inet6-socket-address.h
     utils/ipv4-address.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/helper/trace-helper.cc ns-3.46/src/network/helper/trace-helper.cc
--- ns-3.45/src/network/helper/trace-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/helper/trace-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,8 +15,8 @@
 #include "ns3/pcap-file-wrapper.h"
 #include "ns3/ptr.h"
 
+#include <cstdint>
 #include <fstream>
-#include <stdint.h>
 #include <string>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/model/packet-metadata.cc ns-3.46/src/network/model/packet-metadata.cc
--- ns-3.45/src/network/model/packet-metadata.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/model/packet-metadata.cc	2025-10-01 18:46:32.000000000 -0700
@@ -108,7 +108,6 @@
 bool
 PacketMetadata::IsSharedPointerOk(uint16_t pointer) const
 {
-    NS_LOG_FUNCTION(this << pointer);
     bool ok = pointer == 0xffff || pointer <= m_data->m_size;
     return ok;
 }
@@ -116,7 +115,6 @@
 bool
 PacketMetadata::IsPointerOk(uint16_t pointer) const
 {
-    NS_LOG_FUNCTION(this << pointer);
     bool ok = pointer == 0xffff || pointer <= m_used;
     return ok;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/model/packet-tag-list.h ns-3.46/src/network/model/packet-tag-list.h
--- ns-3.45/src/network/model/packet-tag-list.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/model/packet-tag-list.h	2025-10-01 18:46:32.000000000 -0700
@@ -69,18 +69,18 @@
  * @enddot
  *
  *   - Tags are stored in serialized form in a tree of TagData
- *     structures. (<tt>T1-T7</tt> in the diagram)
+ *     structures. (``T1-T7`` in the diagram)
  *
  *   - Each TagData points (\c next pointers in the diagram)
  *     toward the root of the tree, which is a null pointer.
  *
  *   - \c count is the number of incoming pointers to this
  *     TagData.  Branch points, where branches merge or join, have
- *     <tt>count \> 1</tt> (\c T3, \c T5); successive links along
- *     a branch have <tt>count = 1</tt> (\c T1, \c T2, \c T4, \c T6, \c T7).
+ *     ``count \> 1`` (\c T3, \c T5); successive links along
+ *     a branch have ``count = 1`` (\c T1, \c T2, \c T4, \c T6, \c T7).
  *
  *   - Each PacketTagList points to a specific TagData,
- *     which is the most recent Tag added to the packet. (<tt>T5-T7</tt>)
+ *     which is the most recent Tag added to the packet. (``T5-T7``)
  *
  *   - Conceptually, therefore, each Packet has a PacketTagList which
  *     points to a singly-linked list of TagData.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/model/socket.h ns-3.46/src/network/model/socket.h
--- ns-3.45/src/network/model/socket.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/model/socket.h	2025-10-01 18:46:32.000000000 -0700
@@ -169,7 +169,7 @@
      *        completed. The callback is passed  back a pointer to
      *        the same socket object.
      * @param connectionFailed this callback is invoked when the
-     *        connection request initiated by the user is unsuccessfuly
+     *        connection request initiated by the user is unsuccessfully
      *        completed. The callback is passed back a pointer to the
      *        same socket object.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/crc32.cc ns-3.46/src/network/utils/crc32.cc
--- ns-3.45/src/network/utils/crc32.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/crc32.cc	2025-10-01 18:46:32.000000000 -0700
@@ -13,7 +13,7 @@
  * COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or
  * code or tables extracted from it, as desired without restriction.
  */
-#include <stdint.h>
+#include <cstdint>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/header-serialization-test.h ns-3.46/src/network/utils/header-serialization-test.h
--- ns-3.45/src/network/utils/header-serialization-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/network/utils/header-serialization-test.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors: Davide Magrin <magrin.davide@gmail.com>
+ *          Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef NS3_TEST_HDR_SERIALIZE_H
+#define NS3_TEST_HDR_SERIALIZE_H
+
+#include "ns3/buffer.h"
+#include "ns3/test.h"
+
+/**
+ * @file
+ * @ingroup network
+ * Contains the implementation of the HeaderSerializationTestCase base class.
+ * It is used to generate tests that verify whether a header, when encoded,
+ * then decoded, then re-encoded, matches the original encoded header byte-for-byte.
+ */
+
+namespace ns3
+{
+
+/**
+ * Subclass of TestCase class adding the ability to test the serialization and
+ * deserialization of a Header object.
+ */
+class HeaderSerializationTestCase : public TestCase
+{
+  protected:
+    /**
+     * @brief Constructor.
+     *
+     * @param [in] name The name of the new TestCase created
+     */
+    HeaderSerializationTestCase(std::string name)
+        : TestCase(name)
+    {
+    }
+
+  public:
+    /**
+     * Serialize the given header in a buffer, then create a new header by
+     * deserializing from the buffer and serialize the new header into a new buffer.
+     * Verify that the two buffers have the same size and the same content.
+     *
+     * @tparam T \deduced Type of the given header
+     * @tparam Args \deduced Type of arguments to pass to the constructor of the header
+     * @param [in] hdr the header to test
+     * @param [in] args the arguments to construct the new header
+     */
+    template <typename T, typename... Args>
+    void TestHeaderSerialization(const T& hdr, Args&&... args);
+};
+
+} // namespace ns3
+
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3
+{
+
+template <typename T, typename... Args>
+void
+HeaderSerializationTestCase::TestHeaderSerialization(const T& hdr, Args&&... args)
+{
+    Buffer buffer;
+    buffer.AddAtStart(hdr.GetSerializedSize());
+    hdr.Serialize(buffer.Begin());
+
+    T otherHdr(std::forward<Args>(args)...);
+    otherHdr.Deserialize(buffer.Begin());
+    Buffer otherBuffer;
+    otherBuffer.AddAtStart(otherHdr.GetSerializedSize());
+    otherHdr.Serialize(otherBuffer.Begin());
+
+    NS_TEST_ASSERT_MSG_EQ(buffer.GetSize(), otherBuffer.GetSize(), "Size of buffers differs");
+
+    Buffer::Iterator bufferIterator = buffer.Begin();
+    Buffer::Iterator otherBufferIterator = otherBuffer.Begin();
+    for (uint32_t j = 0; j < buffer.GetSize(); j++)
+    {
+        uint8_t bufferVal = bufferIterator.ReadU8();
+        uint8_t otherBufferVal = otherBufferIterator.ReadU8();
+        NS_TEST_EXPECT_MSG_EQ(+bufferVal,
+                              +otherBufferVal,
+                              "Serialization -> Deserialization -> Serialization "
+                                  << "is different than Serialization at byte " << j);
+    }
+}
+
+} // namespace ns3
+
+#endif /* NS3_TEST_HDR_SERIALIZE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/inet6-socket-address.cc ns-3.46/src/network/utils/inet6-socket-address.cc
--- ns-3.45/src/network/utils/inet6-socket-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/inet6-socket-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -86,7 +86,8 @@
     return addr.CheckCompatible(GetType(), 18); /* 16 (address) + 2  (port) */
 }
 
-Inet6SocketAddress::operator Address() const
+Inet6SocketAddress::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/inet-socket-address.cc ns-3.46/src/network/utils/inet-socket-address.cc
--- ns-3.45/src/network/utils/inet-socket-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/inet-socket-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -86,7 +86,8 @@
     return address.CheckCompatible(GetType(), 6);
 }
 
-InetSocketAddress::operator Address() const
+InetSocketAddress::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/ipv4-address.cc ns-3.46/src/network/utils/ipv4-address.cc
--- ns-3.45/src/network/utils/ipv4-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/ipv4-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -332,7 +332,8 @@
     return address.CheckCompatible(GetType(), 4);
 }
 
-Ipv4Address::operator Address() const
+Ipv4Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/ipv6-address.cc ns-3.46/src/network/utils/ipv6-address.cc
--- ns-3.45/src/network/utils/ipv6-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/ipv6-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -652,7 +652,8 @@
     return address.CheckCompatible(GetType(), 16);
 }
 
-Ipv6Address::operator Address() const
+Ipv6Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/mac16-address.cc ns-3.46/src/network/utils/mac16-address.cc
--- ns-3.45/src/network/utils/mac16-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/mac16-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -68,7 +68,8 @@
     return address.CheckCompatible(GetType(), 2);
 }
 
-Mac16Address::operator Address() const
+Mac16Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/mac48-address.cc ns-3.46/src/network/utils/mac48-address.cc
--- ns-3.45/src/network/utils/mac48-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/mac48-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -68,7 +68,8 @@
     return address.CheckCompatible(GetType(), 6);
 }
 
-Mac48Address::operator Address() const
+Mac48Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/mac64-address.cc ns-3.46/src/network/utils/mac64-address.cc
--- ns-3.45/src/network/utils/mac64-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/mac64-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -83,7 +83,8 @@
     return address.CheckCompatible(GetType(), 8);
 }
 
-Mac64Address::operator Address() const
+Mac64Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/mac8-address.cc ns-3.46/src/network/utils/mac8-address.cc
--- ns-3.45/src/network/utils/mac8-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/mac8-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -56,7 +56,8 @@
     return address.CheckCompatible(GetType(), 1);
 }
 
-Mac8Address::operator Address() const
+Mac8Address::
+operator Address() const
 {
     return ConvertTo();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/packet-burst.cc ns-3.46/src/network/utils/packet-burst.cc
--- ns-3.45/src/network/utils/packet-burst.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/packet-burst.cc	2025-10-01 18:46:32.000000000 -0700
@@ -11,8 +11,8 @@
 #include "ns3/log.h"
 #include "ns3/packet.h"
 
+#include <cstdint>
 #include <list>
-#include <stdint.h>
 
 namespace ns3
 {
@@ -56,7 +56,7 @@
 PacketBurst::Copy() const
 {
     NS_LOG_FUNCTION(this);
-    Ptr<PacketBurst> burst = Create<PacketBurst>();
+    Ptr<PacketBurst> burst = CreateObject<PacketBurst>();
 
     for (auto iter = m_packets.begin(); iter != m_packets.end(); ++iter)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/network/utils/packet-socket-address.cc ns-3.46/src/network/utils/packet-socket-address.cc
--- ns-3.45/src/network/utils/packet-socket-address.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/network/utils/packet-socket-address.cc	2025-10-01 18:46:32.000000000 -0700
@@ -78,7 +78,8 @@
     return m_address;
 }
 
-PacketSocketAddress::operator Address() const
+PacketSocketAddress::
+operator Address() const
 {
     return ConvertTo();
 }
